stages:
  - test
  - versioning
  - deploy

default:
    image: docker:dind
    services:
        - docker:dind

test:
  image: nextstage/php:8.2-fpm-apache
  stage: test
  rules:
      - if: $CI_COMMIT_BRANCH == "main"
        when: on_success
      - if: $CI_COMMIT_BRANCH == "release"
        when: on_success
      - if: $CI_COMMIT_BRANCH == "homolog"
        when: on_success
      - if: $CI_COMMIT_BRANCH == "develop"
        when: on_success
      - when: never      

  script:
      - composer install --no-ansi --no-interaction --no-progress --prefer-dist --dev
      - cp .env.testing .env
      - php artisan key:generate
      - php artisan app:test


versioning:
    image: alpine
    stage: versioning
    when: on_success
    rules:
        - if: $CI_COMMIT_BRANCH == "main"
          when: on_success
        - if: $CI_COMMIT_BRANCH == "release"
          when: on_success
        - if: $CI_COMMIT_BRANCH == "homolog"
          when: on_success
        - if: $CI_COMMIT_BRANCH == "develop"
          when: on_success
        - when: never      
    script:
      - apk update
      - apk add git curl
      - MESSAGE=$(git log -1 --pretty=%B)
      - curl -q --insecure https://storage.googleapis.com/jdrel-devops/tag.sh | sh -s "$MESSAGE"


deploy:
  image: docker:dind
  when: on_success
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      when: on_success
    - if: $CI_COMMIT_BRANCH == "release"
      when: on_success
    - if: $CI_COMMIT_BRANCH == "homolog"
      when: on_success
    - if: $CI_COMMIT_BRANCH == "develop"
      when: on_success
    - when: never      
  environment:
    name: push/$CI_COMMIT_REF_NAME
  script:
    - apk upgrade --update-cache --available
    - apk add openssl
    - apk add curl python3 py-crcmod bash libc6-compat
    - rm -rf /var/cache/apk/*
    - curl https://sdk.cloud.google.com | bash > /dev/null
    - export PATH=$PATH:/root/google-cloud-sdk/bin
    - echo $GCP_SERVICE_KEY > /tmp/gcloud-service-key-push.json
    - gcloud auth activate-service-account --key-file /tmp/gcloud-service-key-push.json
    - gcloud config set project $GCP_PROJECT_ID
    - gcloud auth configure-docker us-east1-docker.pkg.dev
    - docker build --build-arg PHP_VERSION=8.2 -t "us-east1-docker.pkg.dev/$GCP_PROJECT_ID/$GCP_ECR_NAME/api:$CI_COMMIT_REF_SLUG" .
    - docker push "us-east1-docker.pkg.dev/$GCP_PROJECT_ID/$GCP_ECR_NAME/api:$CI_COMMIT_REF_SLUG"
    - |
      rm -R /tmp/gcloud-service-key-push.json
  environment:
    name: push/$CI_COMMIT_REF_NAME
  when: on_success
